# ncurses 5.9 - patch 20110507 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 5.9 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 5.9 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/5.9
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-5.9-20110507.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun May  8 00:57:14 UTC 2011
# ------------------------------------------------------------------------------
# Ada95/aclocal.m4       |   12 ++++++------
# Ada95/configure        |   16 ++++++++--------
# INSTALL                |   27 ++++++++++++++++++++++-----
# NEWS                   |   17 +++++++++++++++--
# dist.mk                |    4 ++--
# misc/ncurses-config.in |   13 ++++++++++---
# ncurses/tinfo/access.c |   15 ++++++++++++---
# test/aclocal.m4        |   12 ++++++------
# test/configure         |   20 ++++++++++----------
# 9 files changed, 91 insertions(+), 45 deletions(-)
# ------------------------------------------------------------------------------
Index: Ada95/aclocal.m4
Prereq:  1.25 
--- ncurses-5.9-20110430+/Ada95/aclocal.m4	2011-04-23 15:30:49.000000000 +0000
+++ ncurses-5.9-20110507/Ada95/aclocal.m4	2011-05-07 15:35:16.000000000 +0000
@@ -28,7 +28,7 @@
 dnl
 dnl Author: Thomas E. Dickey
 dnl
-dnl $Id: aclocal.m4,v 1.25 2011/04/23 15:30:49 tom Exp $
+dnl $Id: aclocal.m4,v 1.26 2011/05/07 15:35:16 tom Exp $
 dnl Macros used in NCURSES Ada95 auto-configuration script.
 dnl
 dnl These macros are maintained separately from NCURSES.  The copyright on
@@ -593,7 +593,7 @@
 fi
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_CURSES_HEADER version: 2 updated: 2010/04/28 06:02:16
+dnl CF_CURSES_HEADER version: 3 updated: 2011/05/01 19:47:45
 dnl ----------------
 dnl Find a "curses" header file, e.g,. "curses.h", or one of the more common
 dnl variations of ncurses' installs.
@@ -603,10 +603,10 @@
 AC_CACHE_CHECK(if we have identified curses headers,cf_cv_ncurses_header,[
 cf_cv_ncurses_header=none
 for cf_header in ifelse($1,,,[ \
-    $1/curses.h \
-	$1/ncurses.h]) \
-	curses.h \
-	ncurses.h ifelse($1,,[ncurses/curses.h ncurses/ncurses.h])
+    $1/ncurses.h \
+	$1/curses.h]) \
+	ncurses.h \
+	curses.h ifelse($1,,[ncurses/ncurses.h ncurses/curses.h])
 do
 AC_TRY_COMPILE([#include <${cf_header}>],
 	[initscr(); tgoto("?", 0,0)],
Index: Ada95/configure
--- ncurses-5.9-20110430+/Ada95/configure	2011-03-31 23:34:47.000000000 +0000
+++ ncurses-5.9-20110507/Ada95/configure	2011-05-07 15:39:29.000000000 +0000
@@ -4519,10 +4519,10 @@
 
 cf_cv_ncurses_header=none
 for cf_header in  \
-    ncursesw/curses.h \
-	ncursesw/ncurses.h \
-	curses.h \
-	ncurses.h
+    ncursesw/ncurses.h \
+	ncursesw/curses.h \
+	ncurses.h \
+	curses.h
 do
 cat >conftest.$ac_ext <<_ACEOF
 #line 4528 "configure"
@@ -5889,10 +5889,10 @@
 
 cf_cv_ncurses_header=none
 for cf_header in  \
-    ncurses/curses.h \
-	ncurses/ncurses.h \
-	curses.h \
-	ncurses.h
+    ncurses/ncurses.h \
+	ncurses/curses.h \
+	ncurses.h \
+	curses.h
 do
 cat >conftest.$ac_ext <<_ACEOF
 #line 5898 "configure"
Index: INSTALL
Prereq:  1.155 
--- ncurses-5.9-20110430+/INSTALL	2011-03-31 08:27:24.000000000 +0000
+++ ncurses-5.9-20110507/INSTALL	2011-05-07 19:39:37.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: INSTALL,v 1.155 2011/03/31 08:27:24 tom Exp $
+-- $Id: INSTALL,v 1.156 2011/05/07 19:39:37 tom Exp $
 ---------------------------------------------------------------------
              How to install Ncurses/Terminfo on your system
 ---------------------------------------------------------------------
@@ -1726,20 +1726,37 @@
 	By default, there are no entries on the fallback list.  After you have
 	built the ncurses suite for the first time, you can change the list
 	(the process needs infocmp(1)).  To do so, use the script
-	ncurses/tinfo/MKfallback.sh.  A configure script option
+	ncurses/tinfo/MKfallback.sh.  The configure script option
 	--with-fallbacks does this (it accepts a comma-separated list of the
 	names you wish, and does not require a rebuild).
 
 	If you wanted (say) to have linux, vt100, and xterm fallbacks, you
-	would use the commands
+	might use the commands
 
 		cd ncurses;
-		tinfo/MKfallback.sh linux vt100 xterm >fallback.c
+		tinfo/MKfallback.sh \
+			$TERMINFO \
+			../misc/terminfo.src \
+			`which tic` \
+			linux vt100 xterm >fallback.c
+
+	The first three parameters of the script are normally supplied by
+	the configured makefiles via the "--with-fallbacks" option.  They
+	are
+
+		1) the location of the terminfo database
+		2) the source for the terminfo entries
+		3) the location of the tic program, used to create a terminfo
+		   database.
 
 	Then just rebuild and reinstall the library as you would normally.
 	You can restore the default empty fallback list with
 
-		tinfo/MKfallback.sh >fallback.c
+		tinfo/MKfallback.sh \
+			$TERMINFO \
+			../misc/terminfo.src \
+			`which tic` \
+			>fallback.c
 
 	The overhead for an empty fallback list is one trivial stub function.
 	Any non-empty fallback list is const-ed and therefore lives in sharable
Index: NEWS
Prereq:  1.1695 
--- ncurses-5.9-20110430+/NEWS	2011-04-30 21:58:29.000000000 +0000
+++ ncurses-5.9-20110507/NEWS	2011-05-07 19:51:09.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.1695 2011/04/30 21:58:29 tom Exp $
+-- $Id: NEWS,v 1.1699 2011/05/07 19:51:09 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,19 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20110507
+	+ update discussion of MKfallback.sh script in INSTALL; normally the
+	  script is used automatically via the configured makefiles.  However
+	  there are still occasions when it might be used directly by packagers
+	  (report by Gunter Schaffler).
+	+ modify misc/ncurses-config.in to omit the "-L" option from the
+	  "--libs" output if the library directory is /usr/lib.
+	+ change order of tests for curses.h versus ncurses.h headers in the
+	  configure scripts for Ada95 and test-directories, to look for
+	  ncurses.h, from fixes to tin -TD
+	+ modify ncurses/tinfo/access.c to account for Tandem's root uid
+	  (report by Joachim Schmitz).
+
 20110430
 	+ modify rules in Ada95/src/Makefile.in to ensure that the PIC option
 	  is not used when building a static library (report by Nicolas
@@ -61,7 +74,7 @@
 	+ add check in test/configure for some legacy curses types of the
 	  function pointer passed to tputs().
 	+ modify init_pair() to accept -1's for color value after
-	  assume_default_colors() has been called (Debian #337905).
+	  assume_default_colors() has been called (Debian #337095).
 	+ modify test/background.c, adding commmand-line options to demonstrate
 	  assume_default_colors() and use_default_colors().
 
Index: dist.mk
Prereq:  1.814 
--- ncurses-5.9-20110430+/dist.mk	2011-04-30 18:20:40.000000000 +0000
+++ ncurses-5.9-20110507/dist.mk	2011-05-07 14:12:36.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.814 2011/04/30 18:20:40 tom Exp $
+# $Id: dist.mk,v 1.815 2011/05/07 14:12:36 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 9
-NCURSES_PATCH = 20110430
+NCURSES_PATCH = 20110507
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: misc/ncurses-config.in
Prereq:  1.25 
--- ncurses-5.9-20110430+/misc/ncurses-config.in	2011-03-19 22:43:38.000000000 +0000
+++ ncurses-5.9-20110507/misc/ncurses-config.in	2011-05-07 19:23:01.000000000 +0000
@@ -1,5 +1,5 @@
 #!@SHELL@
-# $Id: ncurses-config.in,v 1.25 2011/03/19 22:43:38 tom Exp $
+# $Id: ncurses-config.in,v 1.26 2011/05/07 19:23:01 tom Exp $
 ##############################################################################
 # Copyright (c) 2006-2010,2011 Free Software Foundation, Inc.                #
 #                                                                            #
@@ -83,13 +83,19 @@
 ENDECHO
 		;;
 	--libs)
+		if test "$libdir" = /usr/lib
+		then
+			LIBDIR=
+		else
+			LIBDIR=-L$libdir
+		fi
 		if test @TINFO_NAME@ = @LIB_NAME@ ; then
 		sed -e 's,^[ ]*,,' -e 's, [ ]*, ,g' -e 's,[ ]*$,,' <<-ENDECHO
-			-L$libdir @EXTRA_LDFLAGS@ -l${THIS} @LIBS@
+			$LIBDIR @EXTRA_LDFLAGS@ -l${THIS} @LIBS@
 ENDECHO
 		else
 		sed -e 's,^[ ]*,,' -e 's, [ ]*, ,g' -e 's,[ ]*$,,' <<-ENDECHO
-			-L$libdir @EXTRA_LDFLAGS@ -l${THIS} -l${TINFO_LIB} @LIBS@
+			$LIBDIR @EXTRA_LDFLAGS@ -l${THIS} -l${TINFO_LIB} @LIBS@
 ENDECHO
 		fi
 		;;
@@ -163,4 +169,5 @@
 	esac
 	shift
 done
+# vi:ts=4 sw=4
 # vile:shmode
Index: ncurses/tinfo/access.c
Prereq:  1.16 
--- ncurses-5.9-20110430+/ncurses/tinfo/access.c	2010-01-23 17:57:43.000000000 +0000
+++ ncurses-5.9-20110507/ncurses/tinfo/access.c	2011-05-07 15:02:03.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2009,2010 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2010,2011 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,7 +37,15 @@
 
 #include <tic.h>
 
-MODULE_ID("$Id: access.c,v 1.16 2010/01/23 17:57:43 tom Exp $")
+MODULE_ID("$Id: access.c,v 1.17 2011/05/07 15:02:03 tom Exp $")
+
+#ifdef __TANDEM
+#define ROOT_UID 65535
+#endif
+
+#ifndef ROOT_UID
+#define ROOT_UID 0
+#endif
 
 #define LOWERCASE(c) ((isalpha(UChar(c)) && isupper(UChar(c))) ? tolower(UChar(c)) : (c))
 
@@ -170,6 +178,7 @@
 	|| getgid() != getegid())
 	return FALSE;
 #endif
-    return getuid() != 0 && geteuid() != 0;	/* ...finally, disallow root */
+    /* ...finally, disallow root */
+    return (getuid() != ROOT_UID) && (geteuid() != ROOT_UID);
 }
 #endif
Index: test/aclocal.m4
Prereq:  1.59 
--- ncurses-5.9-20110430+/test/aclocal.m4	2011-04-23 23:26:44.000000000 +0000
+++ ncurses-5.9-20110507/test/aclocal.m4	2011-05-07 15:34:44.000000000 +0000
@@ -26,7 +26,7 @@
 dnl authorization.                                                           *
 dnl***************************************************************************
 dnl
-dnl $Id: aclocal.m4,v 1.59 2011/04/23 23:26:44 tom Exp $
+dnl $Id: aclocal.m4,v 1.60 2011/05/07 15:34:44 tom Exp $
 dnl
 dnl Author: Thomas E. Dickey
 dnl
@@ -602,7 +602,7 @@
 done
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_CURSES_HEADER version: 2 updated: 2010/04/28 06:02:16
+dnl CF_CURSES_HEADER version: 3 updated: 2011/05/01 19:47:45
 dnl ----------------
 dnl Find a "curses" header file, e.g,. "curses.h", or one of the more common
 dnl variations of ncurses' installs.
@@ -612,10 +612,10 @@
 AC_CACHE_CHECK(if we have identified curses headers,cf_cv_ncurses_header,[
 cf_cv_ncurses_header=none
 for cf_header in ifelse($1,,,[ \
-    $1/curses.h \
-	$1/ncurses.h]) \
-	curses.h \
-	ncurses.h ifelse($1,,[ncurses/curses.h ncurses/ncurses.h])
+    $1/ncurses.h \
+	$1/curses.h]) \
+	ncurses.h \
+	curses.h ifelse($1,,[ncurses/ncurses.h ncurses/curses.h])
 do
 AC_TRY_COMPILE([#include <${cf_header}>],
 	[initscr(); tgoto("?", 0,0)],
Index: test/configure
--- ncurses-5.9-20110430+/test/configure	2011-04-23 23:27:03.000000000 +0000
+++ ncurses-5.9-20110507/test/configure	2011-05-07 15:39:46.000000000 +0000
@@ -4835,8 +4835,8 @@
 
 cf_cv_ncurses_header=none
 for cf_header in  \
-	curses.h \
-	ncurses.h ncurses/curses.h ncurses/ncurses.h
+	ncurses.h \
+	curses.h ncurses/ncurses.h ncurses/curses.h
 do
 cat >conftest.$ac_ext <<_ACEOF
 #line 4842 "configure"
@@ -5947,10 +5947,10 @@
 
 cf_cv_ncurses_header=none
 for cf_header in  \
-    ncurses/curses.h \
-	ncurses/ncurses.h \
-	curses.h \
-	ncurses.h
+    ncurses/ncurses.h \
+	ncurses/curses.h \
+	ncurses.h \
+	curses.h
 do
 cat >conftest.$ac_ext <<_ACEOF
 #line 5956 "configure"
@@ -7886,10 +7886,10 @@
 
 cf_cv_ncurses_header=none
 for cf_header in  \
-    ncursesw/curses.h \
-	ncursesw/ncurses.h \
-	curses.h \
-	ncurses.h
+    ncursesw/ncurses.h \
+	ncursesw/curses.h \
+	ncurses.h \
+	curses.h
 do
 cat >conftest.$ac_ext <<_ACEOF
 #line 7895 "configure"
